---
title: export
slug: Web/JavaScript/Reference/Statements/export
tags:
  - ECMAScript 2015
  - JavaScript
  - Language feature
  - Modules
  - Reference
  - Statement
  - export
---
<div>{{jsSidebar("Statements")}}</div>

<p><span class="seoSummary">The <strong><code>export</code></strong> statement is used when creating JavaScript modules to export live bindings to functions, objects, or primitive values from the module so they can be used by other programs with the {{jsxref("Statements/import", "import")}} statement. Bindings that are exported can still be modified locally; when imported, although they can only be read by the importing module the value updates whenever it is updated by the exporting module.</span></p>

<p>Exported modules are in {{jsxref("Strict_mode","strict mode", "", 1)}} whether you declare them as such or not. The export statement cannot be used in embedded scripts.</p>

<h2 id="Syntax">Syntax</h2>

<p>There are two types of exports:</p>

<ol>
 <li>Named Exports (Zero or more exports per module)</li>
 <li>Default Exports (One per module)</li>
</ol>

<pre class="syntaxbox notranslate">// Exporting individual features
export let <var>name1</var>, <var>name2</var>, …, <var>nameN</var>; // also var, const
export let <var>name1</var> = …, <var>name2</var> = …, …, <var>nameN</var>; // also var, const
export function functionName(){...}
export class ClassName {...}

// Export list
export { <var>name1</var>, <var>name2</var>, …, <var>nameN</var> };

// Renaming exports
export { <var>variable1</var> as <var>name1</var>, <var>variable2</var> as <var>name2</var>, …, <var>nameN</var> };

// Exporting destructured assignments with renaming
export const { <var>name1</var>, <var>name2: bar</var> } = o;

// Default exports
export default <em>expression</em>;
export default function (…) { … } // also class, function*
export default function name1(…) { … } // also class, function*
export { <var>name1</var> as default, … };

// Aggregating modules
export * from …; // does not set the default export
export * as name1 from …; // Draft ECMAScript® 2O21
export { <var>name1</var>, <var>name2</var>, …, <var>nameN</var> } from …;
export { <var>import1</var> as <var>name1</var>, <var>import2</var> as <var>name2</var>, …, <var>nameN</var> } from …;
export { default } from …;</pre>

<dl>
 <dt><code><var>nameN</var></code></dt>
 <dd>Identifier to be exported (so that it can be imported via {{jsxref("Statements/import", "import")}} in another script).</dd>
</dl>

<h2 id="Description">Description</h2>

<p>There are two different types of export, <strong>named</strong> and <strong>default</strong>. You can have multiple named exports per module but only one default export. Each type corresponds to one of the above syntax:</p>

<p>Named exports:</p>

<pre class="brush: js notranslate">// export features declared earlier
export { myFunction, myVariable };

// export individual features (can export var, let,
// const, function, class)
export let myVariable = Math.sqrt(2);
export function myFunction() { ... };
</pre>

<p>Default exports:</p>

<pre class="brush: js notranslate">// export feature declared earlier as default
export { myFunction as default };

// export individual features as default
export default function () { ... }
export default class { .. }

// each export overwrites the previous one
</pre>

<p>Named exports are useful to export several values. During the import, it is mandatory to use the same name of the corresponding object.</p>

<p>But a default export can be imported with any name for example:</p>

<pre class="brush: js notranslate">// file test.js
let k; export default k = 12;
</pre>

<pre class="brush: js notranslate">// some other file
import m from './test'; // note that we have the freedom to use import m instead of import k, because k was default export
console.log(m);        // will log 12
</pre>

<p>You can also rename named exports to avoid naming conflicts:</p>

<pre class="brush: js notranslate">export { <var>myFunction</var> as <var>function1</var>,<var>
         myVariable</var> as variable };
</pre>

<h3 id="Re-exporting_Aggregating">Re-exporting / Aggregating</h3>

<p>It is also possible to "import/export" from different modules in a parent module so that they are available to import from that module. In other words, one can create a single module concentrating various exports from various modules.</p>

<p>This can be achieved with the "export from" syntax:</p>

<pre class="brush: js notranslate">export { default as function1,
         function2 } from 'bar.js';
</pre>

<p>Which is comparable to a combination of import and export:</p>

<pre class="brush: js notranslate">import { default as function1,
         function2 } from 'bar.js';
export { function1, function2 };
</pre>

<p>But where <code>function1</code> and <code>function2</code> do not become available inside the current module.</p>

<div class="notecard note">
<p><strong>Note:</strong> The following is syntactically invalid despite its import equivalent:</p>
</div>

<pre class="brush: js notranslate">import DefaultExport from 'bar.js'; // Valid
</pre>

<pre class="brush: js notranslate">export DefaultExport from 'bar.js'; // Invalid</pre>

<p>The correct way of doing this is to rename the export:</p>

<pre class="brush: js notranslate">export { default as DefaultExport } from 'bar.js';
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Using_named_exports">Using named exports</h3>

<p>In a module <code>my-module.js</code>, we could include the following code:</p>

<pre class="brush: js notranslate">// module "my-module.js"
function cube(x) {
  return x * x * x;
}

const foo = Math.PI + Math.SQRT2;

var graph = {
  options: {
      color:'white',
      thickness:'2px'
  },
  draw: function() {
      console.log('From graph draw function');
  }
}

export { cube, foo, graph };
</pre>

<p>Then in the top-level module included in your HTML page, we could have:</p>

<pre class="brush: js notranslate">import { cube, foo, graph } from './my-module.js';

graph.options = {
    color:'blue',
    thickness:'3px'
};

graph.draw();
console.log(cube(3)); // 27
console.log(foo);    // 4.555806215962888</pre>

<p>It is important to note the following:</p>

<ul>
 <li>You need to include this script in your HTML with a {{htmlelement("script")}} element of type="module", so that it gets recognised as a module and dealt with appropriately.</li>
 <li>You can't run JS modules via a <code>file://</code> URL — you'll get <a href="/en-US/docs/Web/HTTP/CORS">CORS</a> errors. You need to run it via an HTTP server.</li>
</ul>

<h3 id="Using_the_default_export">Using the default export</h3>

<p>If we want to export a single value or to have a fallback value for your module, you could use a default export:</p>

<pre class="brush: js notranslate">// module "my-module.js"

export default function cube(x) {
  return x * x * x;
}
</pre>

<p>Then, in another script, it is straightforward to import the default export:</p>

<pre class="brush: js notranslate">import cube from './my-module.js';
console.log(cube(3)); // 27
</pre>

<h3 id="Using_export_from">Using export from</h3>

<p>Let's take an example where we have the following hierarchy:</p>

<ul>
 <li><code>childModule1.js</code>: exporting <code>myFunction</code> and <code>myVariable</code></li>
 <li><code>childModule2.js</code>: exporting <code>myClass</code></li>
 <li><code>parentModule.js</code>: acting as an aggregator (and doing nothing else)</li>
 <li>top level module: consuming the exports of <code>parentModule.js</code></li>
</ul>

<p>This is what it would look like using code snippets:</p>

<pre class="brush: js notranslate">// In childModule1.js
let myFunction = ...; // assign something useful to myFunction
let myVariable = ...; // assign something useful to myVariable
export {myFunction, myVariable};
</pre>

<pre class="brush: js notranslate">// In childModule2.js
let myClass = ...; // assign something useful to myClass
export myClass;
</pre>

<pre class="brush: js notranslate">// In parentModule.js
// Only aggregating the exports from childModule1 and childModule2
// to re-export them
export { myFunction, myVariable } from 'childModule1.js';
export { myClass } from 'childModule2.js';
</pre>

<pre class="brush: js notranslate">// In top-level module
// We can consume the exports from a single module since parentModule
// "collected"/"bundled" them in a single source
import { myFunction, myVariable, myClass } from 'parentModule.js'</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-exports', 'Exports')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.statements.export")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Statements/import", "import")}}</li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Modules">JavaScript modules</a> guide</li>
 <li><a href="https://hacks.mozilla.org/2015/08/es6-in-depth-modules/">ES6 in Depth: Modules</a>, Hacks blog post by Jason Orendorff</li>
 <li><a href="https://hacks.mozilla.org/2018/03/es-modules-a-cartoon-deep-dive/">ES modules: A cartoon deep-dive</a>, Hacks blog post by Lin Clark</li>
 <li><a href="http://exploringjs.com/es6/ch_modules.html">Axel Rauschmayer's book: "Exploring JS: Modules"</a></li>
</ul>
